#ifndef __LIS_PRECON_H__
#define __LIS_PRECON_H__

#include "lis_matvec.h"

#ifdef __cplusplus
extern "C"
{
#endif

	/****************************/
	/* preconditioner           */
	/****************************/
	extern int lis_precon_create(LIS_MATRIX Amat, LIS_VECTOR b, int precon_type, LIS_SCALAR params[], int options[], LIS_PRECON *precon);
		extern int  lis_precon_create_ssor(LIS_PRECON precon);
		extern int  lis_precon_create_jacobi(LIS_PRECON precon);
		extern int  lis_precon_create_ilu0(LIS_PRECON precon);
		extern int  lis_precon_create_iluk(LIS_PRECON precon);
		extern int  lis_precon_create_ric2s(LIS_PRECON precon);
		extern int  lis_precon_create_iter(LIS_PRECON precon);
		extern int  lis_precon_create_sainv(LIS_PRECON precon);
		extern int  lis_precon_create_is(LIS_PRECON *precon, LIS_VECTOR b);
		extern int  lis_precon_create_is2(LIS_PRECON precon);
	extern void lis_precon_destroy(LIS_PRECON precon);
	extern void lis_psolve(LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_jacobi(LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_ssor  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_ilu0  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_iluk  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_ric2s (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_iter  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_is    (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_is_1  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_is_2  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolve_sainv   (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
	extern void lis_psolvet(LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_jacobi(LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_ssor  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_ilu0  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_iluk  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_ric2s (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_iter  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_is    (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_is_1  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_is_2  (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
		extern void lis_psolvet_sainv   (LIS_PRECON Precon, LIS_VECTOR b, LIS_VECTOR x);
#ifdef __cplusplus
}
#endif
#endif
